#include <afxwin.h>
#include <windowsx.h>
#include "resource.h"

//
//    class defining declarations
//

class CTheApp : public CWinApp
     {
     public:
	  BOOL InitInstance();
     };


class CMyMainWindow : public CFrameWnd
     {
     public:
	  CMyMainWindow();
	  afx_msg void OnTest();
	  DECLARE_MESSAGE_MAP()
     };


class CMyEditControl : public CEdit
	 {
	 public:
	      afx_msg void OnChar (UINT nChar, UINT nRepCnt, UINT nFlags);

	 DECLARE_MESSAGE_MAP()
	 };


class CMyModalDialog : public CModalDialog
     {
     private:
	  CMyEditControl m_EditControl;

     public:
	  CMyModalDialog (CWnd *pCWndParent = NULL)
		 : CModalDialog ("Dialog_Test", pCWndParent) {;}
	  afx_msg HBRUSH CMyModalDialog::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	  virtual BOOL OnInitDialog();
     };




//    member function definitions
//
//


BOOL CTheApp::InitInstance()
     {
     m_pMainWnd = new CMyMainWindow();
     m_pMainWnd->ShowWindow( m_nCmdShow );
     m_pMainWnd->UpdateWindow();

     return TRUE;
     }


CMyMainWindow::CMyMainWindow()
     {
	 Create (NULL, "Dynamic Subclassing Demo",
     	  WS_OVERLAPPEDWINDOW, rectDefault, NULL, "MainMenu" );
     }

afx_msg void CMyMainWindow::OnTest()
     {
     CMyModalDialog test (this);
     test.DoModal();
     }


CMyModalDialog::OnInitDialog()
     {
     //
     //   dynamically subclass our C++ edit control
     //
     m_EditControl.SubclassDlgItem (IDD_MyEdit, this);
     return TRUE;
     }


afx_msg HBRUSH CMyModalDialog::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
     {
     //
     //   dynamically subclass our C++ edit control
     //
	 if (nCtlColor == CTLCOLOR_DLG)
		  return GetStockBrush (BLACK_BRUSH);
     else
		  return (HBRUSH)Default();
     }


afx_msg void CMyEditControl::OnChar (UINT nChar, UINT nRepCnt, UINT nFlags)
     {
     if (nChar >= 'a' && nChar <= 'z' ||
     	 nChar >= 'A' && nChar <= 'Z' ||
     	 nChar < 0x20) 			// always allow control chars
          CEdit::OnChar (nChar, nRepCnt, nFlags);
     else
	  MessageBeep (0);
     }


//
//    Message Maps
//

BEGIN_MESSAGE_MAP( CMyMainWindow, CFrameWnd )
     ON_COMMAND( IDM_TEST,  OnTest )
END_MESSAGE_MAP()


BEGIN_MESSAGE_MAP( CMyEditControl, CEdit )
     ON_WM_CHAR()
END_MESSAGE_MAP()



//     Start the app
//
//
CTheApp theApp;
