/*------------------------------------------------------------------
   TVDSKTOP.C -- Makes the desktop background display overlay video

                 For use with the VideoBlaster board with the
                 default magenta color key

                 (c) Charles Petzold, 1992
  ------------------------------------------------------------------*/

#include <windows.h>
#include <mmsystem.h>

char szAppName[] = "TVDskTop" ;

long FAR PASCAL _export WndProc (HWND, UINT, UINT, LONG) ;

int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdParam, int nCmdShow)
     {
     HWND        hwnd ;
     MSG         msg ;
     WNDCLASS    wndclass ;

     if (!hPrevInstance)
          {
          wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
          wndclass.lpfnWndProc   = WndProc ;
          wndclass.cbClsExtra    = 0 ;
          wndclass.cbWndExtra    = 0 ;
          wndclass.hInstance     = hInstance ;
          wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
          wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
          wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;
          wndclass.lpszMenuName  = NULL ;
          wndclass.lpszClassName = szAppName ;

          RegisterClass (&wndclass) ;
	  }

     hwnd = CreateWindow (szAppName, "TVDskTop",
                          WS_OVERLAPPEDWINDOW,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          NULL, NULL, hInstance, NULL) ;

     ShowWindow (hwnd, SW_SHOWMINNOACTIVE) ;
     UpdateWindow (hwnd) ;

     while (GetMessage (&msg, NULL, 0, 0))
          {
          TranslateMessage (&msg) ;
          DispatchMessage (&msg) ;
          }
     return msg.wParam ;
     }

long CALLBACK _export WndProc (HWND hwnd, UINT message, UINT wParam,
                                                        LONG lParam)
     {
     static COLORREF cr     = RGB (255, 0, 255),
                     crBack ;
     static int      iColor = COLOR_BACKGROUND ;
     char            szBuffer [32] ;

     switch (message)
          {
          case WM_CREATE:
               if (mciSendString ("open overlay", NULL, 0, NULL))
                    {
                    MessageBox (hwnd, "Cannot open overlay device!",
                                szAppName, MB_OK | MB_ICONEXCLAMATION) ;

                    DestroyWindow (hwnd) ;
                    }

               wsprintf (szBuffer, "window overlay handle %d",
                         GetDesktopWindow ()) ;

               mciSendString (szBuffer, NULL, 0, NULL) ;

                                        // fall through

          case WM_SYSCOLORCHANGE:
               crBack = GetSysColor (COLOR_BACKGROUND) ;
               SetSysColors (1, &iColor, &cr) ;
               return 0 ;

          case WM_QUERYOPEN:
               return 0 ;

          case WM_CLOSE:
               mciSendString ("close overlay", NULL, 0, NULL) ;
               SetSysColors (1, &iColor, &crBack) ;
               break ;

          case WM_DESTROY:
               PostQuitMessage (0) ;
               return 0 ;
          }

     return DefWindowProc (hwnd, message, wParam, lParam) ;
     }
