/*-----------------------------------------
   VIDEOWIN.C -- Video in a Window

                 (c) Charles Petzold, 1992
  -----------------------------------------*/

#include <windows.h>
#include <mmsystem.h>
#include <stdlib.h>

char szAppName[] = "VideoWin" ;

long FAR PASCAL _export WndProc (HWND, UINT, UINT, LONG) ;

int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdParam, int nCmdShow)
     {
     HWND        hwnd ;
     MSG         msg ;
     WNDCLASS    wndclass ;

     if (!hPrevInstance)
          {
          wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
          wndclass.lpfnWndProc   = WndProc ;
          wndclass.cbClsExtra    = 0 ;
          wndclass.cbWndExtra    = 0 ;
          wndclass.hInstance     = hInstance ;
          wndclass.hIcon         = NULL ;
          wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
          wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;
          wndclass.lpszMenuName  = NULL ;
          wndclass.lpszClassName = szAppName ;

          RegisterClass (&wndclass) ;
	  }

     hwnd = CreateWindow (szAppName, "VideoWin",
                          WS_OVERLAPPEDWINDOW,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          NULL, NULL, hInstance, NULL) ;

     ShowWindow (hwnd, nCmdShow) ;
     UpdateWindow (hwnd) ;

     while (GetMessage (&msg, NULL, 0, 0))
          {
          TranslateMessage (&msg) ;
          DispatchMessage (&msg) ;
          }
     return msg.wParam ;
     }

long CALLBACK _export WndProc (HWND hwnd, UINT message, UINT wParam,
                                                        LONG lParam)
     {
     static HWND hwndChild ;
     char        szBuffer [40] ;
     RECT        rect ;

     switch (message)
          {
          case WM_CREATE:
               wsprintf (szBuffer, "open overlay style child parent %d", hwnd) ;

               if (mciSendString (szBuffer, NULL, 0, NULL))
                    {
                    MessageBox (hwnd, "Cannot open overlay device!",
                                szAppName, MB_OK | MB_ICONEXCLAMATION) ;

                    DestroyWindow (hwnd) ;
                    }

               mciSendString ("window overlay state show", NULL, 0, NULL) ;
               mciSendString ("status overlay window handle", szBuffer,
                              sizeof szBuffer, NULL) ;

               hwndChild = atoi (szBuffer) ;

               return 0 ;

          case WM_MOVE:
          case WM_SIZE:
               GetClientRect (hwnd, &rect) ;
               MoveWindow (hwndChild, 0, 0, rect.right, rect.bottom, TRUE) ;

                              // fall through

               GetClientRect (hwnd, &rect) ;

               wsprintf (szBuffer, "put overlay frame at 0 0 %d %d",
                         rect.right, rect.bottom) ;

               mciSendString (szBuffer, NULL, 0, NULL) ;

               wsprintf (szBuffer, "put overlay source at 0 0 %d %d",
                         rect.right, rect.bottom) ;

               mciSendString (szBuffer, NULL, 0, NULL) ;

               wsprintf (szBuffer, "put overlay destination at 0 0 %d %d",
                         rect.right, rect.bottom) ;

               mciSendString (szBuffer, NULL, 0, NULL) ;

               return 0 ;

          case WM_CLOSE:
               mciSendString ("close overlay", NULL, 0, NULL) ;
               break ;

          case WM_DESTROY:
               PostQuitMessage (0) ;
               return 0 ;
          }

     return DefWindowProc (hwnd, message, wParam, lParam) ;
     }
